'user strict';
var async    = require('async');

var xSelector = function (selector) {
    return {
        selector: selector,
        locateStrategy: 'xpath'
    }
};

var canvassCommand= {
    // submit: function() {
    //     this.api.pause(1000);
    //     return this.waitForElementVisible('@submitButton', 1000)
    //         .click('@submitButton')
    //         .waitForElementNotPresent('@submitButton');
    // }
    addSheet: function(sheetName, callback) {
        this.api.pause(1000);

        return this.click('@addSheetButton')
            .waitForElementVisible('@addSheetDialog', 1000)
            .setValue('@sheetName', sheetName)
            .click('@addSheetSubmitButton', callback)
            .waitForElementNotVisible('@addSheetDialog', 1000);
    },
    selectSheet: function(selector, callback) {
        var that = this;
        return this.click(selector, function () {
            that.api.pause(1000, function () {
                if(callback) {
                    callback();
                }
            });
        });
    },
    addNode: function(callback) {
        this.api.pause(1000);
        var that = this;

        return this.waitForElementVisible('@nodeList', 1000)
            .click('@nodeGroup')
            .waitForElementVisible('@node', 1000)
            .click('@node', function(){
                that.api.pause(1000, function () {
                    if(callback) {
                        callback(that);
                    }
                });

            });

    },
    selectNode: function(selector, callback) {
        this.api.pause(1000);

        return this.click(selector, callback);
    },
    copyNode: function(client, selector, mode, callback) {
        this.api.pause(1000);
        var that = this;

        if(mode && mode == 2) {
            client
                .keys([client.Keys.CONTROL, "c"], function (){
                    client.keys(client.Keys.NULL);
                    that.api.pause(1000);
                    if (callback) {
                        callback(that);
                    }
                });
        } else {
            client
                .moveToElement(selector, 10, 10)
                .mouseButtonClick('right', function(){
                    that.waitForElementPresent('@mainContextMenu', 2000)
                        .waitForElementPresent('@copyOption', 2000)
                        .click('@copyOption', function(){
                            that.api.pause(1000, function () {
                                that.waitForElementNotPresent('@mainContextMenu', 1000, function () {
                                    if (callback) {
                                        callback(that);
                                    }
                                });
                            });

                        });

                });
        }

    },
    paste: function(client, selector, mode, callback) {
        this.api.pause(1000);
        var that = this;

        if(mode && mode == 2) {
            client
                .keys([client.Keys.CONTROL, "v"], function (){
                    client.keys(client.Keys.NULL);
                    that.api.pause(2000, function () {
                        if (callback) {
                            callback(that);
                        }
                    });
                });
        } else {
            client
                .moveToElement(selector, 0, 0)
                .mouseButtonClick('right', function(){
                    that.api.pause(1000, function () {
                        that.waitForElementPresent('@mainContextMenu2', 1000)
                            .waitForElementPresent('@pasteOption', 1000)
                            .click('@pasteOption', function(){
                                that.api.pause(2000, function () {
                                    if (callback) {
                                        callback(that);
                                    }
                                });
                            });
                    });
                });
        }

    },
    selectNodes: function(client, selector, mainCallback) {
        var that = this;

        async.series([
            function (callback) {
                client
                    .moveToElement(selector, 0, 0, function () {
                        callback();
                    });
            },
            function (callback) {
                client
                    .mouseButtonDown('left', function(){
                    callback();
                });
            },
            function (callback) {
                client
                    .moveToElement(selector, 1000, 1000, function () {
                        callback();
                    });
            },
            function (callback) {
                that.api.pause(2000, function () {
                    callback();
                });
            },
            function (callback) {
                client
                    .mouseButtonUp('left', function(){
                        if(mainCallback) {
                            mainCallback();
                        }
                        callback();
                    });
            }],
            function () {
                //finished
            });
    },
    deleteNode: function(client, selector, mode, callback) {
        this.api.pause(1000);
        var that = this;

        if(mode && mode == 2) {
            client
                .keys([client.Keys.DELETE], function (){
                    client.keys(client.Keys.NULL);
                    that.api.pause(1000);
                    if (callback) {
                        callback(that);
                    }
                });
        } else {
            client
                .moveToElement(selector, 0, 0)
                .mouseButtonClick('right', function(){
                    that.waitForElementPresent('@mainContextMenu', 2000)
                        .waitForElementPresent('@deleteOption', 2000)
                        .click('@deleteOption', function(){
                            if (callback) {
                                callback(that);
                            }
                        });

                });
        }

    },
    createSheetFromNodes: function(client, selector, sheetName, callback) {
        this.api.pause(1000);
        var that = this;

        client
            .moveToElement(selector, 0, 0)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@mainContextMenu', 2000)
                    .waitForElementPresent('@createSheetFromNodeOption', 2000)
                    .click('@createSheetFromNodeOption').waitForElementVisible('@addSheetDialog', 1000)
                    .setValue('@sheetName', sheetName)
                    .click('@addSheetSubmitButton', function(){
                        that.waitForElementNotVisible('@addSheetDialog', 1000);

                        if (callback) {
                            callback(that);
                        }
                    });

            });
    },
    createNote: function(noteText, client, selector, addNoteDialogSelector, buttonToClick, noteTextAreaSelector, callback) {
        this.api.pause(1000);
        var that = this;

        client
            .moveToElement(selector, 100, 100)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@mainContextMenu2', 1000)
                    .waitForElementPresent('@addNoteOption', 1000)
                    .click('@addNoteOption')
                    .waitForElementVisible(addNoteDialogSelector, 1000)
                    .setValue(noteTextAreaSelector, noteText)
                    .click(buttonToClick, function(){

                        if(callback) {
                            callback(that);
                        }
                    });
            });
    },
    copyNote: function(client, selector, callback) {
        this.api.pause(1000);
        var that = this;

        client
            .moveToElement(selector, 0, 0)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@noteContextMenu', 1000)
                    .waitForElementPresent('@noteCopyOption', 1000)
                    .click('@noteCopyOption', function(){
                        that.waitForElementNotPresent('@noteContextMenu', 1000);

                        if(callback) {
                            callback(that);
                        }
                    });
            });
    },
    editNote: function(noteText, client, selector, callback) {
        this.api.pause(1000);
        var that = this;

        client
            .moveToElement(selector, 0, 0)
            .doubleClick(function(){
                that.waitForElementVisible('@addNoteDialog', 1000)
                    .click('@noteTextArea', function(){
                        client.keys([client.Keys.CONTROL, "a"])
                            .keys(client.Keys.NULL)
                            .keys(client.Keys.DELETE)
                            .keys(client.Keys.NULL);
                        that.setValue('@noteTextArea', noteText)
                            .click('@addNoteButton', function(){
                                that.waitForElementNotVisible('@addNoteDialog', 1000);

                                if(callback) {
                                    callback(that);
                                }
                            });
                    });
            });


    },
    selectNote: function(selector) {
        this.api.pause(1000);

        return this.click(selector);
    },
    deleteNote: function(client, selector, callback) {
        this.api.pause(1000);
        var that = this;

        client
            .moveToElement(selector, 0, 0)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@noteContextMenu', 1000)
                    .waitForElementPresent('@noteDeleteOption', 1000)
                    .click('@noteDeleteOption', function(){
                        that.waitForElementNotPresent('@noteContextMenu', 1000);

                        if(callback) {
                            callback(that);
                        }
                    });
            });
    },
    dragNodeOrNote: function (client, selector, xpos, ypos, callback) {
        this.api.pause(1000);

        client
            .moveToElement(selector, 0, 0)
            .mouseButtonDown('left')
            .moveToElement('body', xpos, ypos)
            .mouseButtonUp('left', function () {
                if(callback) {
                    callback();
                }

            });
    },
    resizeNote: function (client, selector, xpos, ypos, callback) {
        this.api.pause(1000);

        client
            .moveToElement(selector, 0, 0)
            .mouseButtonDown('left')
            .moveToElement('body', xpos, ypos)
            .mouseButtonUp('left', function () {
                if(callback) {
                    callback();
                }

            });
    },
    addInput: function (client, outputName, selector, mainCallback) {
        var that = this;

        async.series([
            function (callback) {
               client.moveToElement(selector,0,0, function () {
                   callback();
               });
            },
            function (callback) {
                client.mouseButtonClick('right', function(){
                    callback();
                });
            },
            function (callback) {
                that.waitForElementPresent('@mainContextMenu', 1000, function () {
                   callback();
                });
            },
            function (callback) {
                that.waitForElementPresent('@addInputOption', 1000, function () {
                   callback();
                });
            },
            function (callback) {
                that.click('@addInputOption', function() {
                    callback();
                });
            },
            function (callback) {
                that.waitForElementVisible('@addInputOutputDialog', 1000, function () {
                    callback();
                });
            },
            function (callback) {
                that.waitForElementVisible('@addInputOutputButton', 1000, function () {
                    callback();
                });
            },
            function (callback) {
                that.clearValue('@addInputOutputText', function () {
                    callback();
                });
            },
            function (callback) {
                that.setValue('@addInputOutputText', outputName, function () {
                    callback();
                });
            },
            function (callback) {
                that.click('@addInputOutputButton', function(){
                     callback();
                });
            },
            function (callback) {
                that.waitForElementNotVisible('@addInputOutputDialog', 1000, function () {
                    if(mainCallback) {
                        mainCallback();
                    }
                    callback();
                });
            }
            ],
            function () {
                //finished
            });

    },
    deleteIO: function(client, deleteIOOptionSelector, selector, mainCallback) {
        var that = this;

        async.series([
            function (callback) {
                client
                    .moveToElement(selector, 3, 3, function () {
                        callback();
                    });
            },
            function (callback) {
                client.mouseButtonClick('right', function(){
                    that.waitForElementPresent('@mainContextMenu2', 1000);
                    callback();
                })
            },
            function (callback) {
                that.waitForElementPresent(deleteIOOptionSelector, 1000, function () {
                    callback();
                });
            },
            function (callback) {
                that.click(deleteIOOptionSelector, function(){
                    that.api.pause(2000);
                    callback();
                });
            },
            function (callback) {
                that.waitForElementNotPresent('@mainContextMenu2', 1000, function(){
                    if(mainCallback) {
                        that.api.pause(1000);
                        mainCallback();
                        callback();
                    }
                });
            }
        ],
        function () {
           //finished
        });

        /*client
            .moveToElement(selector, 3, 3)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@mainContextMenu2', 1000)
                    .waitForElementPresent('@deleteIOOption', 1000)
                    .click('@deleteIOOption', function(){
                        that.api.pause(2000);
                        that.waitForElementNotPresent('@mainContextMenu2', 1000, function(){
                                if(callback) {
                                    callback();
                                }
                            });
                    });

            });*/
    },
    setAsIO: function (client, selector, ioName, callback) {
        var that = this;

        client
            .moveToElement(selector, 3, 3)
            .mouseButtonClick('right', function(){
                that
                    .waitForElementVisible('@mainContextMenu2', 2000)
                    .waitForElementVisible('@setAsIOOption', 2000)
                    .click('@setAsIOOption', function(){
                        that.waitForElementVisible('@setAsIODialog', 1000)
                            .clearValue('@setAsIOText')
                            .setValue('@setAsIOText', ioName)
                            .click('@setAsIOButton', function(){
                                that
                                    .waitForElementNotVisible('@setAsIODialog', 1000);
                                if(callback) {
                                    callback();
                                }
                            });
                    });

            });
    },
    addOutput: function (client, outputName, selector, callback) {
        var that = this;

        client
            .moveToElement(selector, 0, 0)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@mainContextMenu', 2000)
                    .waitForElementPresent('@addOutputOption', 2000)
                    .click('@addOutputOption', function(){
                        that.waitForElementVisible('@addInputOutputDialog', 1000)
                            .clearValue('@addInputOutputText')
                            .setValue('@addInputOutputText', outputName)
                            .click('@addInputOutputButton', function(){
                                that
                                    .waitForElementNotVisible('@addInputOutputDialog', 1000);
                                if(callback) {
                                    callback();
                                }
                            });
                    });

            });
    },
    editProperty: function(client, selector, propertySelector, propertyDialogSelector, value, propertyDialogOkSelector, mainCallback) {
        var that = this;

        async.series([
            function (callback) {
                that.openProperty(client, selector, propertySelector, propertyDialogSelector, function () {
                    callback();
                });
            },
            function (callback) {
                that.clearValue(propertySelector, function () {
                   callback();
                });
            },
            function (callback) {
                that.setValue(propertySelector, value, function () {
                    callback();
                });
            },
            function (callback) {
                that.closeProperty(propertyDialogOkSelector, function () {
                    that.api.pause(1000);
                    mainCallback();
                    callback();
                })
            }
        ],
        function () {
            //finished
        });
    },
    openProperty: function (client, selector, propertySelector, propertyDialogSelector, mainCallback) {
        var that = this;
        async.series([
            function (callback) {
                client.moveToElement(selector, 0, 0)
                    .mouseButtonClick('right', function(){
                        callback();
                    });
            },
            function (callback) {
                that.waitForElementPresent('@mainContextMenu', 2000)
                    .waitForElementPresent('@propertyOption', 2000)
                    .click('@propertyOption', function(){
                        that.api.pause(1000);
                        callback();
                    });
            },
            function (callback) {
                that.waitForElementVisible(propertyDialogSelector, 2000)
                    .waitForElementVisible(propertySelector, 1000, function () {
                        that.api.pause(1000);
                        mainCallback();
                        callback();
                    });
            }
        ],
        function () {
            //finished
        });
    },
    closeProperty: function (propertyDialogOkSelector, mainCallback) {
        var that = this;
        this.click(propertyDialogOkSelector, function () {
            that.api.pause(1000);
            mainCallback();
        });
    },
    setAsCondition: function (client, selector, mainCallback) {
        var that = this;

        async.series([
                function (callback) {
                    client.moveToElement(selector, 3, 3)
                        .mouseButtonClick('right', function(){
                            callback();
                        });
                },
                function (callback) {
                    that.waitForElementPresent('@mainContextMenu2', 2000)
                        .waitForElementPresent('@setAsConditionOption', 2000, function () {
                            callback();
                        });
                },
                function (callback) {
                    that.click('@setAsConditionOption', function(){
                        that.api.pause(1000);
                        mainCallback();
                        callback();
                    });
                }
            ],
            function () {
                //finished
            });
    },
    deleteCondition: function(client, selector, mainCallback) {
        var that = this;

        async.series([
                function (callback) {
                    client
                        .moveToElement(selector, 3, 3, function () {
                            callback();
                        });
                },
                function (callback) {
                    client.mouseButtonClick('right', function(){
                        that.waitForElementPresent('@mainContextMenu2', 1000);
                        callback();
                    })
                },
                function (callback) {
                    that.waitForElementPresent('@deleteConditionOption', 1000, function () {
                        callback();
                    });
                },
                function (callback) {
                    that.click('@deleteConditionOption', function(){
                        that.api.pause(2000);
                        callback();
                    });
                },
                function (callback) {
                    that.waitForElementNotPresent('@mainContextMenu2', 1000, function(){
                        if(mainCallback) {
                            that.api.pause(1000);
                            mainCallback();
                            callback();
                        }
                    });
                }
            ],
            function () {
                //finished
            });

    },
    linkNodes: function(client, fromSelector, toSelector, xpos, ypos, callback) {
        client
            .moveToElement(fromSelector, 3, 0)
            .mouseButtonDown('left')
            .pause(1000)
            .moveToElement(fromSelector, xpos, ypos) //drag somewhere near the Node terminal
            .pause(1000)
            .moveToElement(toSelector, 3, 0)
            .mouseButtonUp('left', function () {
                if(callback) {
                    callback();
                }
            });
    },
    deleteLink: function(client, selector, callback) {
        var that = this;

        client
            .moveToElement(selector, 3, 3)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@terminalMenu', 2000)
                    .waitForElementPresent('@deleteLinkOption', 2000)
                    .click('@deleteLinkOption', function(){
                        if(callback) {
                            callback();
                        }
                    });
            });
    },
    showHelp: function(client, selector, mainCallback) {
        this.api.pause(1000);

        var that = this;

        async.series([
            function (callback) {
                client.moveToElement(selector, 0, 0, function () {
                    callback();
                });
            },
            function (callback) {
                client.mouseButtonClick('right', function(){
                    callback();
                });
            },
            function (callback) {
                that.waitForElementPresent('@mainContextMenu', 1000, function () {
                   callback();
                });
            },
            function (callback) {
                that.waitForElementPresent('@helpOption', 1000, function () {
                    callback();
                })
            },
            function (callback) {
                that.click('@helpOption', function(){
                    if(mainCallback) {
                        mainCallback(that);
                    }

                    callback();
                });
            }
            ],
        function () {
           //end
        });

        /*client
            .moveToElement(selector, 0, 0)
            .mouseButtonClick('right', function(){
                that.waitForElementPresent('@mainContextMenu', 1000)
                    .waitForElementPresent('@helpOption', 1000)
                    .click('@helpOption', function(){
                        that.waitForElementNotPresent('@mainContextMenu', 1000, function () {
                            if(callback) {
                                callback(that);
                            }
                        });
                    });
            });*/
    },
    setProcess: function(client, selector, callback) {
        var that = this;

        async.series([
            function (callback) {

            }
        ],
        function () {
           //finished
        });

    },
    setTheme: function(client, selector, themeSelector, mainCallback) {
        var that = this;

        async.series([
            function (callback) {
                client.moveToElement(selector, 0, 0)
                    .mouseButtonClick('right', function(){
                        callback();
                    });
            },
            function (callback) {
                that.waitForElementPresent('@mainContextMenu', 2000)
                    .waitForElementPresent('@themeOption', 2000, function () {
                        callback();
                    });
            },
            function (callback) {
                client.moveToElement('body > ul > li.context-menu-item.context-menu-submenu', 3, 3, function () {
                   that.api.pause(2000);
                    callback();
                });
            },
            function (callback) {
                that.waitForElementVisible('@themeMenu', 2000, function () {
                    callback();
                });
            },
            function (callback) {
                that.click(themeSelector, function () {
                    mainCallback();
                    callback();
                });
            }
        ],
        function () {
            //finished
        });

    },
    saveNetwork: function (client, sheetName, callback) {
        var that = this;
        this.click('@saveSheetMenuButton')
            .waitForElementVisible('@saveSheetDialog', 1000)
            .clearValue('@sheetNameInput')
            .setValue('@sheetNameInput', sheetName)
            .click('@saveNetworkButton', function () {
                that.api.pause(1000, function () {
                    client.getAlertText(function(alertText){
                        if(alertText.value == 'Overwrite network?') {
                            //accept alert
                            client.acceptAlert(function () {
                                that.api.pause(1000);
                                if (callback) {
                                    callback();
                                }
                            });
                        }
                        else {
                            if(callback) {
                                callback();
                            }
                        }
                    });
                });
            });
    },
    loadNetwork: function (client, sheetName, mainCallback){
        var that = this;
        this.api.pause(2000);
        async.series([
            function (callback) {
                that.click('@fileButton' , function () {
                    callback();
                });
            },
            function (callback) {
                that.waitForElementVisible('@fileDialog', 1000)
                    .clearValue('@fileSearchInput')
                    .setValue('@fileSearchInput', sheetName, function () {
                        that.api.pause(2000, function () {
                            callback();
                        });
                    });
            },
            function (callback) {
                that.waitForElementVisible('@fileSearchFirstItem', 1000)
                    .waitForElementVisible('@fileSearchFirstItemLoadButton', 1000, function () {
                        that.api.pause(2000, function () {
                            callback();
                        });
                    });
            },
            function (callback) {
                that.click('@fileSearchFirstItemLoadButton', function () {
                    that.api.pause(2000, function () {
                        callback();
                    });
                });
            },
            function (callback) {
                //check if alert text is correct
                client.getAlertText(function(alertText){
                    client.assert.equal(alertText.value, 'Current network will be cleaned. OK?');

                    //accept alert
                    client.acceptAlert(function () {
                        that.api.pause(3000, function () {
                            if(mainCallback) {
                                mainCallback();
                            }
                            callback();
                        });
                    });
                });
            }
            ],
            function () {
                //finished
            });

    },
    loadFixture: function (client, mainCallback) {
        var that = this;
        var defaultPath = '';
        this.api.pause(2000);
        async.series([
            function (callback) {
                that.click('@fileButton', function () {
                    callback();
                });
            },
            function (callback) {
                that.waitForElementVisible('@fileDialog', 1000)
                    .getValue('@fileNameInput', function (result) {
                        defaultPath = result.value;
                        callback();
                    });
            },
            function (callback) {
                that.setValue('@fileNameInput', '/../../automated-tests/lib/fixtures', function () {
                    callback();
                });
            },
            function (callback) {
                client.keys([client.Keys.ENTER], function () {
                    client.keys(client.Keys.NULL);
                    callback();
                });
            },
            function (callback) {
                that.clearValue('@fileSearchInput')
                    .setValue('@fileSearchInput', 'canvass_test_fixture.n', function () {
                        that.api.pause(5000, function () {
                            callback();
                        });
                    });
            },
            function (callback) {
                that.waitForElementVisible('@fileSearchFirstItem', 1000)
                    .waitForElementVisible('@fileSearchFirstItemLoadButton', 1000, function () {
                        that.api.pause(1000);
                        callback();
                    });
            },
            function (callback) {
                that.click('@fileSearchFirstItemLoadButton', function () {
                    that.api.pause(2000, function () {
                        callback();
                    });
                });
            },
            function (callback) {
                //check if alert text is correct
                client.getAlertText(function(alertText){
                        if(alertText) {
                            client.assert.equal(alertText.value, 'Current network will be cleaned. OK?');
                        }

                        //accept alert
                        client.acceptAlert(function () {
                            that.api.pause(2000, function () {
                                callback();
                            });
                        });
                });
            },
            function (callback) {
                that
                    .click('@fileButton', function () {
                        that.api.pause(2000, function () {
                            callback();
                        });
                    });
            },
            function (callback) {
                that.waitForElementVisible('@fileDialog', 1000)
                    .clearValue('@fileNameInput')
                    .setValue('@fileNameInput', defaultPath, function() {
                        callback();
                    });
            },
            function (callback) {
                client.keys([client.Keys.ENTER], function () {
                    client.keys(client.Keys.NULL);
                    callback();
                });
            },
            function (callback) {
                that.click('@fileDialogCloseButton', function () {
                    if (mainCallback) {
                        mainCallback();
                        callback();
                    }
                })
            }
            ],
            function(){
                //finished
            });

    },
    addNodeByName: function(nodeName, mainCallback) {
        var that = this;

        async.series([
                function (callback) {
                    //search for node
                    that.setValue('@searchInput', nodeName, function () {
                        callback();
                    });
                },
                function (callback) {
                    //check if there is search result
                    that.waitForElementVisible('@firstSearchResult', 1000, function () {
                        callback();
                    });
                },
                function (callback) {
                    //add node to canvass
                    that.click('@firstSearchResult', function () {
                        that.api.pause(2000);
                        callback();
                    });
                },
                function (callback) {
                    //clear input
                    that.clearValue('@searchInput', function () {
                        callback();
                    });
                },
                function (callback) {
                    //pause
                    that.api.pause(2000, function () {
                       if(mainCallback) {
                           mainCallback();
                       }
                       callback();
                    });
                }
            ],
            function () {
                //finished
            });
    },
    repositionNode: function (client, selector, xpos, ypos, callback) {
        //reposition nodeChannelSelector1
        client
            .moveToElement(selector, 0, 0)
            .mouseButtonDown('left')
            .moveToElement('body', xpos, ypos)
            .mouseButtonUp('left', function () {
                callback();
            });
    }
};

module.exports = {
    url: 'http://localhost:3000',
    commands: [canvassCommand],
    elements: {
        mainSheet: xSelector('//*[@id="canvas2_MAIN"]'),
        mainSheetTab: xSelector('//*[@id="sheets"]/ul/li[2]'),
        mainContextMenu: xSelector('/html/body/ul[1]'),
        copyOption: xSelector('/html/body/ul/li/span[contains(text(),"Copy")]'),
        pasteOption: xSelector('/html/body/ul/li/span[contains(text(),"Paste")]'),
        deleteOption: xSelector('/html/body/ul/li/span[contains(text(),"Delete")]'),
        helpOption: xSelector('/html/body/ul/li/span[contains(text(),"Help")]'),
        nodeGroup: xSelector('//*[@id="nodelist"]/li[1]'),
        node: xSelector('//*[@id="nodelist"]/li[1]/ul/li[1]'),
        nodeList: xSelector('//*[@id="nodelist"]'),
        nodeDOM: xSelector('//*[@id="node_NNetExec_1"]'),
        mainContextMenu2: xSelector('/html/body/ul[1]'),
        nodeDOM2: xSelector('//*[@id="node_NNetExec_2"]'),
        addSheetButton: xSelector('//*[@id="addSheetButton"]'),
        addSheetDialog: xSelector('//div[contains(@aria-describedby, "addSheetDialog")]'),
        sheetName: xSelector('//*[@id="addSheetName"]'),
        sheetType: xSelector('//*[@id="addSheetType"]'),
        addSheetSubmitButton: xSelector('//div[contains(@aria-describedby, "addSheetDialog")]/div[3]/div/button[1]'),
        addSheetCancelButton: xSelector('//div[contains(@aria-describedby, "addSheetDialog")]/div[3]/div/button[2]'),
        sheet1: xSelector('//*[@id="canvas2_test1"]'),
        sheet1Tab: xSelector('//*[@id="sheets"]/ul/li[3]'),
        sheet2: xSelector('//*[@id="canvas2_test2"]'),
        sheet2Tab: xSelector('//*[@id="sheets"]/ul/li[4]'),
        nodeDOM3: xSelector('//*[@id="node_NNetExec_3"]'),
        nodeDOM4: xSelector('//*[@id="node_NNetExec_4"]'),
        nodeDOM5: xSelector('//*[@id="node_NNetExec_5"]'),
        nodeDOM6: xSelector('//*[@id="node_NNetExec_6"]'),
        nodeDOM7: xSelector('//*[@id="node_NNetExec_7"]'),
        nodeDOM8: xSelector('//*[@id="node_NNetExec_8"]'),
        nodeDOM9: xSelector('//*[@id="node_NNetExec_9"]'),
        nodeDOM10: xSelector('//*[@id="node_NNetExec_10"]'),
        nodeDOM11: xSelector('//*[@id="node_NNetExec_11"]'),
        nodeDOM12: xSelector('//*[@id="node_NNetExec_12"]'),
        nodeDOM13: xSelector('//*[@id="node_NNetExec_13"]'),
        createSheetFromNodeOption: xSelector('/html/body/ul/li/span[contains(text(),"Create sheet from selected")]'),
        addNoteOption: xSelector('/html/body/ul[1]/li/span[contains(text(),"Add Note")]'),
        addNoteDialog: xSelector('//*[@id="addNoteDialog"]'),
        addNote0Dialog: xSelector('//*[contains(@aria-describedby, "textCont_note0")]'),
        addNote0DialogOkButton: xSelector('//*[contains(@aria-describedby, "textCont_note0")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"OK")]'),
        addNote0DialogCancelButton: xSelector('//*[contains(@aria-describedby, "textCont_note0")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"Cancel")]'),
        addNote0DialogTextArea: xSelector('//*[contains(@aria-describedby, "textCont_note0")]/div/textarea'),
        noteTextArea: xSelector('//*[@id="addNoteDialog"]/textarea'),
        addNoteButton: xSelector('//div[contains(@aria-describedby, "addNoteDialog")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"OK")]'),
        cancelNoteButton: xSelector('//div[contains(@aria-describedby, "addNoteDialog")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"Cancel")]'),
        note1: xSelector('//*[@id="note0"]/div'),
        noteContextMenu: xSelector('/html/body/ul[1]'),
        noteCopyOption: xSelector('/html/body/ul[1]/li/span[contains(text(),"Copy")]'),
        noteDeleteOption: xSelector('/html/body/ul[1]/li/span[contains(text(),"Delete")]'),
        note2: xSelector('//*[@id="note1"]/div'),
        addNote1Dialog: xSelector('//*[contains(@aria-describedby, "textCont_note1")]'),
        addNote1DialogOkButton: xSelector('//*[contains(@aria-describedby, "textCont_note1")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"OK")]'),
        addNote1DialogCancelButton: xSelector('//*[contains(@aria-describedby, "textCont_note1")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"Cancel")]'),
        addNote1DialogTextArea: xSelector('//*[contains(@aria-describedby, "textCont_note1")]/div/textarea'),
        terminalMenu: xSelector('/html/body/ul[1]'),
        deleteLinkOption: xSelector('/html/body/ul/li/span[contains(text(),"Delete the link")]'),
        nodeChannelSelector1: xSelector('//*[@id="node_ChannelSelector_1"]'),
        saveSheetMenuButton: xSelector('//*[@id="save"]'),
        saveSheetDialog: xSelector('//*[contains(@aria-describedby, "saveFileDialog")]'),
        sheetNameInput: xSelector('//*[@id="networkName"]'),
        saveNetworkButton: xSelector('//*[contains(@aria-describedby, "saveFileDialog")]/div[3]/div/button[1]'),
        fileButton: xSelector('//*[@id="fileManagerButton"]'),
        fileDialog: xSelector('//*[@aria-describedby="fileManagerDialog"]'),
        fileSearchInput: xSelector('//*[@id="fileManagerDialog"]/form/input'),
        fileSearchFirstItem: xSelector('//*[@id="grid"]/table/tbody/tr[1]/td[1]'),
        fileSearchFirstItemLoadButton: xSelector('//*[@id="grid"]/table/tbody/tr[1]/td[3]/button[2]'),
        networkFixtureLoadButton: xSelector('//div/div/div/div/table/tbody/tr/td[text()="canvass_test_fixture.n"]/following-sibling::td/button[2]'),
        searchInput: xSelector('//*[@id="nodelistSearch"]/input'),
        firstSearchResult: xSelector('//*[@id="flatNodelist"]/li[1]'),
        addInputOption: xSelector('/html/body/ul[1]/li/span[contains(text(),"Add Input")]'),
        addOutputOption: xSelector('/html/body/ul[1]/li/span[contains(text(),"Add Output")]'),
        addInputOutputDialog: xSelector('/html/body/div[7]'),
        addInputOutputText: xSelector('//*[@id="IOName"]'),
        addInputOutputButton: xSelector('//div[contains(@aria-describedby, "AddIODialog")]/div[contains(@class, "ui-dialog-buttonpane")]/div/button/span[contains(text(),"Add")]'),
        nodeLocalizeMUSICInput: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_INPUT"]'),
        nodeLocalizeMUSICInput1: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_INPUT_1"]'),
        nodeLocalizeMUSICInput2: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_INPUT_2"]'),
        nodeLocalizeMUSIC1: xSelector('//*[@id="node_LocalizeMUSIC_1"]'),
        deleteIOOption: xSelector('/html/body/ul[1]/li[2]'),
        setAsIOOption: xSelector('/html/body/ul[1]/li[1]'),
        deleteIOOption2: xSelector('/html/body/ul[1]/li[1]'),
        setAsIODialog: xSelector('//*[contains(@aria-describedby, "terminalRoleNameDialog")]'),
        setAsIOText: xSelector('//*[@id="terminalRoleName"]'),
        setAsIOButton: xSelector('//*[contains(@aria-describedby, "terminalRoleNameDialog")]/div[3]/div/button[1]'),
        inputRole: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_INPUT"]/div/span'),
        input1Role: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_INPUT_1"]/div/span'),
        noisecmRole: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_NOISECM"]/div/span'),
        nodeLocalizeMUSICOutput: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_OUTPUT"]'),
        nodeLocalizeMUSICOutput1: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_OUTPUT_1"]'),
        nodeLocalizeMUSICOutput2: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_OUTPUT_2"]'),
        outputRole: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_OUTPUT"]/div/span'),
        output1Role: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_OUTPUT_1"]/div/span'),
        fileNameInput: xSelector('//*[@id="datapath"]'),
        fileDialogCloseButton: xSelector('//*[@aria-describedby="fileManagerDialog"]/div[1]/button'),
        propertyOption: xSelector('/html/body/ul/li/span[contains(text(),"Property")]'),
        propertyDialog: xSelector('/html/body/div[15]'),
        lengthPropertyInput: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_parametersForm"]/table/tbody/tr[3]/td[3]/input'),
        propertyDialogOkButton: xSelector('/html/body/div[15]/div[3]/div/button[1]'),
        nodeLocalizeMusic1PropertyDialog: xSelector('//*[@aria-describedby="node_LocalizeMUSIC_1_delim_parameters"]'),
        nodeLocalizeMusic1PropertyDialogOkButton: xSelector('//*[@aria-describedby="node_LocalizeMUSIC_1_delim_parameters"]/div[3]/div/button[1]'),
        dynamic1Sheet: xSelector('//*[@id="sheet_Dynamic1"]'),
        dynamic1SheetTab: xSelector('//*[@id="sheets"]/ul/li[3]'),
        nodeLocalizeMUSIC2: xSelector('//*[@id="node_LocalizeMUSIC_2"]'),
        inputRole2: xSelector('//*[@id="node_LocalizeMUSIC_2_delim_INPUT"]/div/span'),
        dynamic1Node: xSelector('//*[@id="node_Dynamic1_1"]'),
        dynamic1NodeInput: xSelector('//*[@id="node_Dynamic1_1_delim_INPUT"]'),
        dynamic1SheetDeleteIOOption: xSelector('/html/body/ul[1]/li[1]'),
        outputRole2: xSelector('//*[@id="node_LocalizeMUSIC_2_delim_OUTPUT"]/div/span'),
        dynamic1NodeOutput: xSelector('//*[@id="node_Dynamic1_1_delim_OUTPUT"]'),
        dynamic2Sheet: xSelector('//*[@id="sheet_Dynamic2"]'),
        dynamic2SheetTab: xSelector('//*[@id="sheets"]/ul/li[4]'),
        nodeLocalizeMUSIC3: xSelector('//*[@id="node_LocalizeMUSIC_3"]'),
        inputRole3: xSelector('//*[@id="node_LocalizeMUSIC_3_delim_INPUT"]/div/span'),
        dynamic2Node: xSelector('//*[@id="node_Dynamic2_1"]'),
        dynamic2NodeInput: xSelector('//*[@id="node_Dynamic2_1_delim_INPUT"]'),
        dynamic2SheetDeleteIOOption: xSelector('/html/body/ul[1]/li[1]'),
        outputRole3: xSelector('//*[@id="node_LocalizeMUSIC_3_delim_OUTPUT"]/div/span'),
        dynamic2NodeOutput: xSelector('//*[@id="node_Dynamic2_1_delim_OUTPUT"]'),
        nodeLocalizeMusic1LENGTH: xSelector('//*[@id="node_LocalizeMUSIC_1_delim_parametersForm"]/table/tbody/tr[3]/td[3]/input'),
        setAsConditionOption: xSelector('/html/body/ul[1]/li[2]'),
        deleteConditionOption: xSelector('/html/body/ul[1]/li[2]'),
        nodeAudioStreamFromWave1: xSelector('//*[@id="node_AudioStreamFromWave_1"]'),
        nodeAudioStreamFromWave1CONDITION: xSelector('//*[@id="node_AudioStreamFromWave_1_delim_NOT_EOF"]/div/span'),
        nodeNormalizeMUSIC1CONDITION: xSelector('//*[@id="node_NormalizeMUSIC_1_delim_01_SPEC"]/div/span'),
        consoleText: xSelector('//*[@id="executeStatus"]'),
        themeOption: xSelector('/html/body/ul/li[14]'),
        themeMenu: xSelector('/html/body/ul/li[14]/ul'),
        fireThemeOption: xSelector('/html/body/ul/li[14]/ul/li[1]'),
        seaThemeOption: xSelector('/html/body/ul/li[14]/ul/li[2]'),
        darkThemeOption: xSelector('/html/body/ul/li[14]/ul/li[3]'),
        classicThemeOption: xSelector('/html/body/ul/li[14]/ul/li[4]'),
        nodeLOOP1: xSelector('//*[@id="node_LOOP_1"]'),
        nodeConstant1: xSelector('//*[@id="node_Constant_1"]'),
        nodeConstant2: xSelector('//*[@id="node_Constant_2"]'),
        nodeConstant3: xSelector('//*[@id="node_Constant_3"]'),
        nodeInputStream2: xSelector('//*[@id="node_InputStream_2"]'),
        nodeLOOP2: xSelector('//*[@id="node_LOOP_2"]')
    }
};